/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef COMPRESSORRESPONSEFILTER_H_
#define COMPRESSORRESPONSEFILTER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "abstractresponsefilter.h"
#include "httpresponsemetadata.h"
#include "abstractcompressor.h"

using namespace std;

class CompressorResponseFilter : public AbstractResponseFilter
{
public:
	enum compr_type { C_DEFLATE, C_GZIP };
	CompressorResponseFilter(compr_type type);
	virtual ~CompressorResponseFilter();
	virtual void consumeMetadata(HttpResponseMetadata& metadata);
	virtual void consumeDataChunk(const string& data);
	virtual void consumeEOF();
	virtual bool isMetadataReady() const { return (m_metadata ? true : false); }
	virtual bool hasDataAvailable() const;
	virtual void readDataChunk(string& collector);
	virtual bool isEOF() const { return m_eof; }
private:
	compr_type m_type;
	AbstractCompressor *m_delegate;
	HttpResponseMetadata *m_metadata;
	string m_processed_data;
	bool m_eof;
};

#endif

