/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTMLTAGINFO_H_
#define HTMLTAGINFO_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <map>

using namespace std;

// This class only has to contain the tags listed in HTMLProcessor::m_important_tags
class HTMLTagInfo
{
public:
	enum etag_status_enum { ETAG_REQUIRED, ETAG_OPTIONAL, ETAG_FORBIDDEN };
	class Info
	{
	public:
		Info() : m_unknown(true) {}
		Info(etag_status_enum etag_status) : m_unknown(false), m_etag_status(etag_status) {}
		bool m_unknown;
		etag_status_enum m_etag_status;
	};
	typedef map<string, Info> taglist_type;
	static const Info& getInfoOn(const string& tagname);
private:
	static void loadTags();
	static taglist_type m_tags;
	static bool m_tags_loaded;
	static Info m_default_info;
};

#endif

