/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef IMAGEINSPECTOR_H_
#define IMAGEINSPECTOR_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "abstractimageinspector.h"

using namespace std;

class ImageInspector : public AbstractImageInspector
{
public:
	enum type { T_UNKNOWN, T_JPEG, T_GIF, T_PNG };
	ImageInspector();
	virtual ~ImageInspector();
	virtual void consumeData(const string& data);
	virtual void consumeEOF();
	virtual const string& getAccumulatedData() const;
	virtual void reset();
	virtual bool isInspectionInProgress() const;
	virtual bool isInspectionFailed() const;
	virtual int getWidth() const;
	virtual int getHeight() const;
	virtual bool isAnimated() const;
	type getImageType() const { return m_type; }
private:
	enum state { ST_SIGNATURE, ST_DELEGATION, ST_UNKNOWN_TYPE };
	state m_state;
	type m_type;
	string m_data;
	AbstractImageInspector *m_delegate;
};

#endif

