/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef STRINGTOKENIZER_H_
#define STRINGTOKENIZER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>

using namespace std;

class StringTokenizer
{
public:
	StringTokenizer(const string& str, const string& delim=" \t\n\r\f", bool return_delims=false);
	bool hasMoreTokens();
	string nextToken();
private:
	const string m_str;
	const string m_delim;
	const bool m_return_delims;
	string::size_type m_cur_pos;
	string m_next_token;
};

#endif

