/*
    BFilter - a smart ad-filtering http proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef UTILS_H_
#define UTILS_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <sstream>
#include <list>

using namespace std;

template<class NumType>
string num2str(NumType arg)
{
	ostringstream strm;
	strm << arg;
	return strm.str();
}

template<class NumType>
NumType str2num(const string& arg, NumType dflt=0)
{
	istringstream strm(arg);
	NumType res = dflt;
	strm >> res;
	return res;
}

void chomp(string& str);
string ltrim(const string& str);
string rtrim(const string& str);
string trim(const string& str);
bool string_starts_with(const string& str, const string& prefix);
bool string_ends_with(const string& str, const string& trailer);

string join(const string& glue, const list<string>& arr);
string strtolower(const string& str);
string strtoupper(const string& str);
string str_replace(const string& search, const string& replace, const string& subject);
string htmlencode(const string& str);
string htmldecode(const string& str);

#endif
