#!/bin/sh

if [ ! -d NSIS ]
then
  echo "You have to copy the NSIS directory here."
  echo "NSIS can be found at http://nsis.sf.net"
  exit 1
fi

mkdir temp
windres -i resource.rc -I rc -o resource.res -O coff
gcc -INSIS/Contrib/ExDLL -O2 -mwindows -shared unwarn.c resource.res -o Unwarn.dll
rm -f resource.res
strip Unwarn.dll
mv Unwarn.dll temp
cp ../main/bfilter.exe temp/bfilter.exe
cp /mingw/bin/mingwm10.dll temp/mingwm10.dll
mkdir temp/doc
cp ../doc/*.html temp/doc/
cp ../doc/*.png temp/doc/
./unix2dos.sh bfilter.nsi > temp/bfilter.nsi
./unix2dos.sh lastpage.ini > temp/lastpage.ini
./unix2dos.sh ../COPYING > temp/License.txt
./unix2dos.sh ../conf/config.default > temp/config.default
./unix2dos.sh ../conf/rules > temp/rules
./unix2dos.sh ../conf/rules.local > temp/rules.local

(cd temp && ../NSIS/makensis.exe bfilter.nsi && mv bfilter-*-install.exe ../)

rm -Rf temp
